; ####################
; #####	StrCmp	#####
; ####################

; An unsafe but fast string comparison routine
; **** WARNING - Buffer overflow risk ****
; IN:
;		pString1, pString2 - pointers to the strings
; RETURNS:
;		 0 	if not equal
;		-1 	if equal
;
; Note regarding StrCmp's name decoration: _StrCmp@8
; 1.Prefix  an external function with an underscore
; 2.Postfix with the number of bytes of parameters passed

_StrCmp@8 frame pString1, pString2
	uses esi,edi
	mov esi,d[pString1]	; esi -> pString1
	mov edi,d[pString2]	; edi -> pString2
	test esi,esi				; is esi a null string?
	jz > _null_string		; if so, goto null_string
	test edi,edi				; is edi a null string?
	jz > _not_equal			; if so, goto not_equal
	mov ecx,[esi-8]			; get the length of pString1
	mov eax,[edi-8]			; get the length of pString2
	cmp ecx,eax					; are they the same length?
	jne > _not_equal		; if not, they are not equal
	cmp ecx,4						; is it less than 4 bytes?
	jle > _test_dword		; if so, do the quick test
	mov edx,8						; test 8 bytes per pass

_test_qword:
	mov eax,[edi]				; get four bytes of pString2
	cmp [esi],eax				; compare to four bytes of pString1
	jne > _not_equal		; if not equal, goto not_equal
	mov eax,[edi+4]			; get four bytes of pString2
	cmp [esi+4],eax			; compare to four bytes of pString1
	jne > _not_equal		; if not equal, goto not_equal
	sub ecx,edx					; decrement our counter
	jle > _equal				; if counter <= 0, they are equal
	add esi,edx					; increment our pointer
	add edi,edx					; increment our pointer
	cmp ecx,4						; is it less than 4 bytes?
	jg <_test_qword			; if not, go again

_test_dword:					; test the last 4 bytes as a dword
	mov eax,[edi]				; get four bytes of pString2
	cmp [esi],eax				; compare to four bytes of pString1
	jne > _not_equal		; if not equal, goto not_equal

_equal:								; they are equal
	mov eax,-1					; return -1 (TRUE)
	ret									; return to calling function

_null_string:					; esi is null
	test edi,edi				; is edi null?
	jz < _equal					; if so, they are equal

_not_equal:						; not equal
	xor eax,eax					; return 0 (FALSE)
	ret									; return to calling function
endf
