CONSOLE
'
' Validation of pool TEST
'
	IMPORT "xst"         ' Xblite Standard Library
	IMPORT "xsx"         ' Xblite Standard eXtended Library
'
'
DECLARE FUNCTION Entry () ' program entry point
'
' === TEST pool ===
'
GRAB "accessors/declare.x" ' "$1" := "TEST"
GRAB "accessors/declare02.x" ' "$1" := "TEST"
GRAB "accessors/declare03.x" ' "$1" := "TEST"

FUNCTION Entry ()

	? "Validation of pool TEST"
	? "=================="
	?
	bInvalid = $$FALSE		' assume valid

	TEST_Init ()		' initialize the TEST pool

	? "adding 20 items for testing."
	?

	FOR n = 1 TO 20
		TEST_item$ = LCASE$ ("TEST") + FORMAT$ ("00", n)
		? "Adding TEST item '"; TEST_item$; "'"
		TEST_idNew = TEST_New (TEST_item$)
		IFZ TEST_idNew THEN PRINT "TEST_New: Can't add item '"; TEST_item$; "' to the TEST pool"
	NEXT n
	TEST_idMaxOld = TEST_Get_idMax ()

' (Validation of pool's id, count and getter)
	?
	TEST_count = TEST_Get_count ()
	? "List all"; TEST_count; " items"

	FOR TEST_id = 1 TO TEST_idMaxOld
		bOK = TEST_Get (TEST_id, @TEST_item$)
		IFF bOK THEN		' deleted
			? "TEST_Get: Can't get TEST item"; TEST_id
		ELSE
			IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
			? id$; ". '"; TEST_item$; "'"
		ENDIF
	NEXT TEST_id

' (Validation of pool's search routines)
	?
	TEST_idFound = 19
	searchFor$ = LCASE$ ("TEST") + FORMAT$ ("00", TEST_idFound)

	? "find '"; searchFor$; "'"
	TEST_idFound = TEST_Find (searchFor$)
	IFZ TEST_idFound THEN ? "Can't find TEST item '"; searchFor$; "'"
	IF TEST_idFound = TEST_idFound THEN
		? "OK!"
	ELSE
		? "error"
		bInvalid = $$TRUE
	ENDIF

	?
	bErr = TEST_Reorg ()
	IF bErr THEN
		? "TEST_Reorg: Can't prepare TEST_BinSearch"
	ENDIF
	? "TEST_BinSearch: Searching for '"; searchFor$; "'"
	TEST_id = TEST_BinSearch (searchFor$)   ' binary search
	IF TEST_id > 0 THEN
		? "TEST item id:"; TEST_id; " is an exact match for '"; searchFor$; "'; OK!"
	ELSE
		? searchFor$; " not found; error"
		bInvalid = $$TRUE
	ENDIF

	?
	' capitalize the first letter
	searchFor$ = UCASE$(LEFT$ (searchFor$)) + LCLIP$ (searchFor$)

	? "find insensitive '"; searchFor$; "'"
	id = TEST_FindIns (searchFor$)
	IFZ id THEN
		? "Can't find (case insensitive) TEST item '"; searchFor$; "'";
	ELSE
	? "Found TEST item '"; searchFor$; "', id ="; id;
	ENDIF
	IF id = TEST_idFound THEN
		? "; OK!"
	ELSE
		? "; error"
		bInvalid = $$TRUE
	ENDIF

	?
	searchFor$ = LCASE$ ("TEST") + id$
	TEST_item$ = "new_" + searchFor$

	? "change '"; searchFor$; "'"; " to '"; TEST_item$; "'"

	TEST_idFound = TEST_Find (searchFor$)
	IFZ TEST_idFound THEN
		? "Error: item '"; searchFor$; "'"; " not found!"
	ELSE
		TEST_Update (TEST_idFound, TEST_item$)
		bOK = TEST_Get (TEST_idFound, @TEST_item$)
		IFF bOK THEN
			? "Error: can't get TEST item"; TEST_idFound
		ELSE
			IF TEST_item$ = TEST_item$ THEN
				? "OK! can get TEST item TEST_idFound ="; TEST_idFound; " with its updated value ("; TEST_item$; ")"
			ELSE
				? "Bad: can get TEST item TEST_idFound ="; TEST_idFound; " but its value "; TEST_item$; " was not updated"
			ENDIF
		ENDIF
	ENDIF

	?
	idDel = TEST_idFound
	searchFor$ = TEST_item$
	? "Deleting '"; searchFor$; "'"

	TEST_idFound = TEST_Find (searchFor$)
	IFZ TEST_idFound THEN
		? "Error: TEST item '"; searchFor$; "'"; " not found"
	ELSE
		? "- delete '"; searchFor$; "'"
		TEST_Delete (TEST_idFound)
		? "- get '"; searchFor$; "'"
		bOK = TEST_Get (TEST_idFound, @TEST_item$)
		? "TEST item"; TEST_idFound; " was deleted; ";
		IF bOK THEN
			? "error"
			bInvalid = $$TRUE
		ELSE
			? "OK!"
		ENDIF
	ENDIF

	?
	TEST_id = TEST_idFound
	? "Deleting AGAIN '"; searchFor$; "'"; ", item id was"; TEST_id
	bOK = TEST_Delete (TEST_id)
	? "TEST item"; TEST_idFound; " was deleted; ";
	IF bOK THEN
		? "bOK == $$TRUE; OK!"
	ELSE
		? "bOK == $$FALSE; error"
		bInvalid = $$TRUE
	ENDIF

' (Validation of pool's delete routine)
	?
	? "Deleting first  item"
	TEST_idMin = TEST_Get_idMin ()
	bOK = TEST_Delete (TEST_idMin)
	IFF bOK THEN ? "Error: first item was NOT deleted"

	? "Deleting second item"
	TEST_idMin = TEST_Get_idMin ()
	bOK = TEST_Delete (TEST_idMin)
	IFF bOK THEN ? "Error: first item was NOT deleted"

	? "Deleting last   item"
	TEST_idMaxOld = TEST_Get_idMax ()
	bOK = TEST_Delete (TEST_idMaxOld)
	IFF bOK THEN ? "Error: last item was NOT deleted"

' (Validation of pool's add routine)
	TEST_item$ = "new_item01"
	? "Adding TEST_item$ first item "; TEST_item$
	TEST_idNew = TEST_New (TEST_item$)
	IFZ TEST_idNew THEN PRINT "TEST_New: Can't add item = "; TEST_item$; " to its pool TEST"

	?
	TEST_idMin = TEST_Get_idMin ()
	? "First item id:"; TEST_idMin

	TEST_idMaxOld = TEST_Get_idMax ()
	? "Last  item id:"; TEST_idMaxOld
	? "Item count   :"; TEST_Get_count ()
	?
	? "List all"; TEST_Get_count (); " items"
	FOR TEST_id = TEST_idMin TO TEST_idMaxOld
		bOK = TEST_Get (TEST_id, @TEST_item$)
		IF bOK THEN
			IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
			? id$; ". '"; TEST_item$; "'"
		ELSE
			IF TEST_Active (TEST_id) THEN
				? "TEST item"; TEST_id; " was NOT deleted; bad!"
			ELSE
				? "TEST item"; TEST_id; " was deleted; OK!"
			ENDIF
		ENDIF
	NEXT TEST_id

	?
	?
	? "Same list using TEST_GetNext"

	' *** walk thru the TEST pool
	TEST_id = 0
	DO WHILE TEST_GetNext (@TEST_id, @TEST_item$)
		IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
		? id$; ". '"; TEST_item$; "'"
		'
		IFF TEST_Active (TEST_id) THEN
			? "TEST item"; TEST_id; " was deleted; error"
			bInvalid = $$TRUE
		ENDIF
	LOOP
	IFZ TEST_id THEN
		? "TEST pool is empty"
	ENDIF

' (Validation of a sorted pool's routines)
	?
	bErr = TEST_Reorg ()
	IF bErr THEN
		? "TEST_Reorg: Can't prepare TEST_BinSearch"
	ELSE
		? "Reorganized list"
		TEST_id = 0
		DO WHILE TEST_GetNext (@TEST_id, @TEST_item$)
			IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
			? id$; ". '"; TEST_item$; "'"
		LOOP
	ENDIF

' (Validation of negative hits)
	?
	searchFor$ = LCASE$ ("TEST") + "01"
	? "TEST_BinSearch: Searching for '"; searchFor$; "'"
	TEST_id = TEST_BinSearch (searchFor$)   ' binary search
	IF TEST_id > 0 THEN
		? "TEST item id: " + STRING$ (TEST_id) + " is an exact match for " + searchFor$; "'; error"
		bInvalid = $$TRUE
	ELSE
		? searchFor$; " not found; OK!"
	ENDIF

	?
	searchFor$ = "new_item01"
	? "TEST_BinSearch: Searching for '"; searchFor$; "'"
	TEST_id = TEST_BinSearch (searchFor$)   ' binary search
	IF TEST_id > 0 THEN
		? "TEST item id: " + STRING$ (TEST_id) + " is an exact match for '" + searchFor$; "'; OK!"
	ELSE
		? searchFor$; " not found; error"
		bInvalid = $$TRUE
	ENDIF

' (Validation of the search hits)
	?
	?
	? "Validation of the search hits"
	? "============================="

	FOR n = 21 TO 0 STEP -1
		?
		searchFor$ = LCASE$ ("TEST") + FORMAT$ ("00", n)
		? "TEST_BinSearch: Searching for '"; searchFor$; "'"
		TEST_id = TEST_BinSearch (searchFor$)   ' binary search
		IF TEST_id > 0 THEN
			' search hit
			? "TEST item id: " + STRING$ (TEST_id) + " is an exact match for '" + searchFor$; "'"
		ELSE
			' negative hit
			? "'"; searchFor$; "' not found"
		ENDIF
	NEXT n

' (Validation of pool's clear routine)
	?
	? "Validation of TEST_Clear()"

	TEST_Clear ()		' clear TEST pool

	TEST_id = 0
	DO WHILE TEST_GetNext (@TEST_id, @TEST_item$)
		IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
		? id$; ". '"; TEST_item$; "'"
	LOOP

	IFZ TEST_id THEN
		? "TEST pool is empty; OK!"
	ELSE
		? "TEST pool is NOT empty; error"
		bInvalid = $$TRUE
	ENDIF

	IF TEST_Get_count () THEN
		? "TEST pool is NOT empty; error"
		bInvalid = $$TRUE
	ENDIF
	?
	?
	IF bInvalid THEN
		? "?????????????????????"
		? "? Invalid pool TEST ?"
		? "?????????????????????"
	ELSE
		? "********************"
		? "* Pool TEST is OK! *"
		? "********************"
	ENDIF

	a$ = INLINE$ ("\nPress Enter to quit >")
	QUIT (0)

END FUNCTION
'
'
' === TEST pool ===
'
GRAB "accessors/define.x" ' "$1" := "TEST"
GRAB "accessors/define02.x" ' "$1" := "TEST"
GRAB "accessors/define03.x" ' "$1" := "TEST"

END PROGRAM