'
' Checks if $1 item is currently active.
' $1_id = item id of $1 item
' RETURNs bOK: $$TRUE if active.
'
' Usage:
' IFF $1_Active ($1_id) THEN
'  PRINT "$1_Active: $1 item id "; $1_id; " is inactive"
' ENDIF
'
FUNCTION $1_Active ($1_id)
	SHARED $1_poolUM[]

	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN RETURN $$TRUE
	ENDIF
END FUNCTION
'
' Gets the the number of $1 items.
'
FUNCTION $1_Get_count ()
	SHARED $1_poolUM[]

	count = 0
	IF $1_poolUM[] THEN
		FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
			IF $1_poolUM[slot] THEN INC count
		NEXT slot
	ENDIF
	RETURN count
END FUNCTION
'
' Gets lower $1 item id.
'
' Usage:
'	$1_count = $1_Get_count ()
'	IF $1_count THEN
'		' *** walk thru the $1 pool
'		$1_idMin = $1_Get_idMin ()
'		$1_idMax = $1_Get_idMax ()
'		FOR $1_id = $1_idMin TO $1_idMax
'			bOK = $1_Get ($1_id, @$1_item)
'			IFF bOK THEN DO NEXT		' deleted
'		NEXT $1_id
'	ENDIF
'
FUNCTION $1_Get_idMin ()
	SHARED $1_poolUM[]

	idMin = 0
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = 0 TO upper_slot
			IF $1_poolUM[slot] THEN
				idMin = slot + 1
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	RETURN idMin
END FUNCTION
'
' Gets next $1 item.
' $1_id = the id of the RETURNed item
' $1_item = RETURNed item
' RETURNs bOK: $$TRUE on success.
'
' Usage:
'	' *** walk thru the $1 pool
'	$1_id = 0
'	DO WHILE $1_GetNext (@$1_id, @$1_item)
'	LOOP
'	IFZ $1_id THEN
'		PRINT "$1 pool is empty"
'	ENDIF
'
FUNCTION $1_GetNext (@$1_id, $1 $1_item)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	bOK = $$FALSE
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = $1_id TO upper_slot
			IF $1_poolUM[slot] THEN
				bOK = $$TRUE
				$1_id = slot + 1
				$1_item = $1_pool[slot]
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	IFF bOK THEN
		$1_item = $1_null
	ENDIF
	RETURN bOK
END FUNCTION